package io.renren.modules.sys.service.impl;

import io.renren.modules.sys.entity.algs.Algorithm_Vo;
import io.renren.modules.sys.service.CategoryService;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import io.renren.common.utils.PageUtils;
import io.renren.common.utils.Query;

import io.renren.modules.sys.dao.VisiWorkflowDao;
import io.renren.modules.sys.entity.VisiWorkflowEntity;
import io.renren.modules.sys.service.VisiWorkflowService;


@Service("visiWorkflowService")
public class VisiWorkflowServiceImpl extends ServiceImpl<VisiWorkflowDao, VisiWorkflowEntity> implements VisiWorkflowService {

    @Autowired
    VisiWorkflowDao visiWorkflowDao;
//    @Autowired
//    CategoryService categoryService;

    @Override
    public PageUtils queryPage(Map<String, Object> params) {
        IPage<VisiWorkflowEntity> page = this.page(
                new Query<VisiWorkflowEntity>().getPage(params),
                new QueryWrapper<VisiWorkflowEntity>()
        );

        return new PageUtils(page);
    }

    //获取模板列表,使用的是@select连表查询
    //但是怎么把搜索功能加进去呢？？？？
    @Override
    public PageUtils queryPageOnUse(Map<String, Object> params) {
        //获取搜索框搜索的模板名称.
        String experimentName = (String)params.get("experimentName");
//        String classificationtag = (String)params.get("classificationtag");

//        Long categoryId = categoryService.getByName(classificationtag);
        //获取当前登录的用户,如果是管理员的话，uid就为null
        Long uid = (Long) params.get("currentUserId");
        System.out.println("uid: "+ uid);
        List<VisiWorkflowEntity> workflowInfo;
        List<VisiWorkflowEntity> workflowAllInfo;
        int pageSize = Integer.valueOf((String) params.get("limit"));
        int pageIndex = Integer.valueOf((String) params.get("page"));

//        此方法如果修改,则也需要修改下面的获取总页数的方法
        workflowInfo =visiWorkflowDao.getWorkflowInfo(new QueryWrapper<VisiWorkflowEntity>()
                        .like(StringUtils.isNotBlank(experimentName), "experiment_name", experimentName)
                        //根据登录的用户展示他自己的模板
                        .eq(uid != null, "a.user_id", uid)
                        .orderByDesc("workflow_id")
//                使用limit用于分页,下面的函数没有limit进行分页
                        .last("limit " + (pageIndex - 1) * pageSize + "," + pageSize + ";")

        );

        //用于查全部，获取总页数。
        workflowAllInfo = visiWorkflowDao.getWorkflowInfo(new QueryWrapper<VisiWorkflowEntity>()
                .like(StringUtils.isNotBlank(experimentName), "experiment_name", experimentName)
                //根据登录的用户展示他自己的模板
                .eq(uid != null, "a.user_id", uid)
        );

//        for (VisiWorkflowEntity visiWorkflowEntity : workflowInfo) {
//            vo.setCategoryName(categoryService.getById(vo.getCategoryId()).getCategoryName());
//        }

        //弃用的方法
        //这个方法：根据当前登录的用户id返回只有当前用户的数据，但是没有结合搜索框搜索
        //templateInfo = algorithmTemplateVoMapper.getTemplateInfoById(uid);
        return new PageUtils(workflowInfo, workflowAllInfo.size(), pageSize, pageIndex);

    }
}
